# TDT4109 ITGK Øvinger

Dette er en [git-repo][git-repo] hvor jeg samler opp alle øvingene for TDT4109.

## Kjøring

Flere av skriptene deler funksjoner fra mappen `common`. For at disse skal kjøre på en korrekt måte, må de kjøres som moduler og ikke alenestående skript.

Eksempel på hvordan man skal kjøre en fil (OBS: Legg merke til forskjell på . og /):

```bash
  python3 -m "Exercise 3.11 - Doble lokker.11a"
```

Eksempel på hvordan man **ikke** skal kjøre filen:

```bash
  python3 "Exercise 3/11 - Doble lokker/11a.py"
```

## Testing

Hver oppgave kommer med eksempel på kjøring, og dette eksempelet i tillegg til andre eksempler blir testet med python sitt innebygde bibliotek som heter `unittest`. Hver øving har en mappe som heter test, hvor alle testene for de forskjellige skriptene ligger, og man kan automatisk teste en av- eller alle filene med kommandoen:

```bash
  python -m unittest -s 'Exercise <x>/test'
```

## Komprimering og innlevering

I hovedmappa ligger det en fil med navn `zipExercise.py`. Denne tar inn ett mappenavn som argument, og sørger for å inkludere alle `common`-modulene som ble brukt, fjerne `__pycache__`, i tillegg til å kopiere denne readme-filen inn i zip-mappa.

Eksempel på bruk:

```bash
python zipExercise.py "./Exercise 3"
```

[git-repo]: https://gitlab.stud.idi.ntnu.no/oysteikt/tdt4109-itgk/